PKCS7_DECRYPT(3)

NAME
PKCS7_decrypt - decrypt content from a PKCS#7 envelopedData structure

SYNOPSIS
#include <openssl/pkcs7.h>
int
PKCS7_decrypt(PKCS7 *p7, EVP_PKEY *pkey, X509 *cert, BIO *data, int flags);

DESCRIPTION
PKCS7_decrypt() extracts and decrypts the content from a PKCS#7 envelopedData structure. pkey is the private key of the recipient, cert is the recipient's certificate, data is a BIO to write the content to and flags is an optional set of flags.

OpenSSL_add_all_algorithms(3) (or equivalent) should be called before using this function or errors about unknown algorithms will occur.

Although the recipient's certificate is not needed to decrypt the data, it is needed to locate the appropriate recipients in the PKCS#7 structure.

If the PKCS7_TEXT flag is set, MIME headers for type text/plain are deleted from the content. If the content is not of type text/plain, an error is returned.

RETURN VALUES
PKCS7_decrypt() returns 1 for success or 0 for failure.

The error can be obtained from ERR_get_error(3).

SEE ALSO
ERR_get_error(3), PKCS7_encrypt(3), PKCS7_new(3)

HISTORY
PKCS7_decrypt() was added to OpenSSL 0.9.5.

BUGS
PKCS7_decrypt() must be passed the correct recipient key and certificate. It would be better if it could look up the correct key and certificate from a database.

The lack of single pass processing and need to hold all data in memory as mentioned in PKCS7_sign(3) also applies to PKCS7_decrypt().